-- 跨服消费排行
Lua_CrossServerConsumeWindow  = class("Lua_CrossServerConsumeWindow", Lua_Window);
function Lua_CrossServerConsumeWindow:ctor(p)
	self:superCall("ctor");

	self.windowName = "Lua_CrossServerConsumeWindow";
	self.skinName = "CrossServerConsumeWindow_skin";
end

function Lua_CrossServerConsumeWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.leftTipsLab.text = LanUtil.getValue(141003);
	self.rankTxt.text = LanUtil.getValue(141008);

	self.red:setEnable(false);
	self.noRoleIcon:setEnable(false);
	self.subBtn:setBtnEnable(false);
	self.titleNameIcon:setEnable(false);

	self.awardList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 347, 428));
	self.awardList:setLocation(-364, -56, 0);
	self.awardList:setListCell(Lua_CrossConsumeAwardItem, 104, 347, 1);

	self.rankList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 341, 180));
	self.rankList:setLocation(351, 45, 0);
	self.rankList:setListCell(Lua_CrossConsumeRankItem, 49, 341, 1);

	self.showRewardList = Lua_DragList.new(self.content, 2, Vector4(0, 0, 222, 80));
	self.showRewardList:setLocation(351, -201.5, 0);
	self.showRewardList:setListCell(Lua_CrossConsumeShowRewardItem, 80, 80, 100);

	self.rItem = Lua_RewardItem.new(self.content);
	self.rItem:setMaxShow(5);
	self.rItem:setLayout(65, 65, 7);
	self.rItem:setDepth(10);
	self.rItem:setClickWin(true);
	self.rItem:setMouseEnble(true);
	self.rItem:setItemScale(0.7, 0.7);
	self.rItem:setLocation(-141, -234, 0);

	self.help:addClickFuntion(self,self.onHelp); -- 问号
	self.last:addClickFuntion(self, self.onSubClick); -- 上一页;
	self.next:addClickFuntion(self, self.onAddClick); -- 下一页;
	self.rechargeBtn:addClickFuntion(self, self.onRechargeClick); -- 前往充值;
	self.subBtn:addClickFuntion(self, self.onAwardeClick); -- 领取奖励;

	self:addLuaEvent("UPDARE_RECHERGE_INFO", self, self.updateRechargeInfo); -- 界面信息
	self:addLuaEvent("UPDARE_AWARD_INFO", self, self.updateAwardInfo); -- 领取奖励后单独更新
	self:addLuaEvent("UPDTAE_PALY_INFO", self, self.showPalyModel); -- 更新某个玩家信息
	Lua_ProxyManager.getProxy("Lua_CrossServerRechargeProxy"):sUseConsumeInfo();
end

function Lua_CrossServerConsumeWindow:updateRechargeInfo()
	local crossServerRechargeData = DataCenter.crossServerRechargeData;
	local awardArr = crossServerRechargeData.getRankRewaedInfo;
	local rankArr = crossServerRechargeData.getRankInfo;
	self.awardList:setLuaArrayData(awardArr, true);
	self.rankList:setLuaArrayData(rankArr, true);

	self.endTime = crossServerRechargeData.end_tick;
	self:startTimer();
	self:updateConsumeLeftTime();

	self.rItem:setRewardByArray(crossServerRechargeData.getFirstAward);
	self.rankTipsLab.text = crossServerRechargeData.content;
	self.nameTxt.text = crossServerRechargeData.getFirstName;
	self.centerTipsLab.text = crossServerRechargeData.getFirstRechargeNum;
	self.myRankLab.text = crossServerRechargeData.rank_dic;

	if crossServerRechargeData.isHaveFirst then
		self.noRoleIcon:setEnable(false);
		Lua_ProxyManager.getProxy("Lua_CrossServerRechargeProxy"):sUseConsumePalyInfo(rankArr[1].role_id, rankArr[1].server_flag);
	else
		self.noRoleIcon:setEnable(true);
		if self.playerModel ~= nil then
			self.playerModel:dispose();
		end
	end

	if crossServerRechargeData.travel_act == 1 then
		self.titleNameIcon:setAltas("crossServerRecharge_atlas", "ui_kfxfph_z01"); -- 跨服消费排行
		self.titleNameIcon:SetDimensions(306, 54);
		self.titleNameIcon:setLocation(-167, 270, 0);
	else
		self.titleNameIcon:setAltas("crossServerRecharge_atlas", "ui_xfph_z01"); -- 消费排行
		self.titleNameIcon:SetDimensions(204, 54);
		self.titleNameIcon:setLocation(-122, 270, 0);
	end
	self.titleNameIcon:setEnable(true);
	self:updateAwardInfo();
end

function Lua_CrossServerConsumeWindow:startTimer()
	if self.countDown ~= true then
		self.countDown = true;
		Lua_CommonUtil.addTimer("Lua_CrossServerConsumeWindow", 1, self, self.updateConsumeLeftTime);
	end
end

function Lua_CrossServerConsumeWindow:updateConsumeLeftTime()
	local leftTime = self.endTime - DataCenter.roleData.serverTime - 1;
	self.timeLab.text = LanUtil.formateStr(LanUtil.getValue(141001), TimeTransform.getInstance():transSeconds1(leftTime, true));
	if leftTime <= 0 then
		self.timeLab.text = LanUtil.formateStr(LanUtil.getValue(141001), tostring(0)).."[FF1616]"..LanUtil.getValue(26).."[-]";
		self:endTimer();
	end
end

function Lua_CrossServerConsumeWindow:endTimer()
	if self.countDown == true then
		self.countDown = false;
		Lua_CommonUtil.removeTimer(self, self.updateConsumeLeftTime);
	end
end

function Lua_CrossServerConsumeWindow:updateAwardInfo()
	self.rewardLab.text = LanUtil.formateStr(LanUtil.getValue(141018), tostring(DataCenter.crossServerRechargeData.total_gold));
	if DataCenter.crossServerRechargeData.getAwardIndex == 1 then
		DataCenter.crossServerRechargeData.consume_index = 1;
	else
		DataCenter.crossServerRechargeData.consume_index = DataCenter.crossServerRechargeData.getAwardIndex;
	end
	local info = DataCenter.crossServerRechargeData:getAccRewaedInfo(DataCenter.crossServerRechargeData.consume_index);
	self:updateExtraAwardInfo(info) -- 更新额外奖励数据
end

-- 更新额外奖励数据
function Lua_CrossServerConsumeWindow:updateExtraAwardInfo(data)
	self.data = data;
	self.rechargeLab.text = "[85A8BE]" .. data.content .. "[-]";
	self.showRewardList:setLuaArrayData(data.itemArr, true);

	if DataCenter.crossServerRechargeData.is_max_select_index then
		self.next.mouseEnable = false;
		-- self.next:setGray(true);
		self.next:setAltas("common_atlas_2", "ui_common_jiantou_02");

		self.last.mouseEnable = true;
		-- self.last:setGray(false);
		self.last:setAltas("common_atlas_2", "ui_common_jiantou_01");
	else
		self.next.mouseEnable = true;
		-- self.next:setGray(false);
		self.next:setAltas("common_atlas_2", "ui_common_jiantou_01");

		self.last.mouseEnable = DataCenter.crossServerRechargeData.consume_index ~= 1;
		-- self.last:setGray(DataCenter.crossServerRechargeData.consume_index == 1);
		if DataCenter.crossServerRechargeData.consume_index == 1 then
			self.last:setAltas("common_atlas_2", "ui_common_jiantou_02");
		else
			self.last:setAltas("common_atlas_2", "ui_common_jiantou_01");
		end
	end
	self.last:setSacle(-0.8, 0.8);
	self.next:setSacle(0.8, 0.8);

	self.red:setEnable(data.state == 1);
	self.subBtn:setBtnEnable(data.state == 1);

	if data.state == 2 then
		self.subBtn.label = LanUtil.getValue(121912);
	else
		self.subBtn.label = LanUtil.getValue(121148);
	end
end

function Lua_CrossServerConsumeWindow:onSubClick()
	DataCenter.crossServerRechargeData.consume_index = DataCenter.crossServerRechargeData.consume_index  - 1;
	if DataCenter.crossServerRechargeData.consume_index == 0 then
		DataCenter.crossServerRechargeData.consume_index = 1;
	end
	local info = DataCenter.crossServerRechargeData:getAccRewaedInfo(DataCenter.crossServerRechargeData.consume_index)
	self:updateExtraAwardInfo(info) -- 更新额外奖励数据
end

function Lua_CrossServerConsumeWindow:onAddClick()
	DataCenter.crossServerRechargeData.consume_index = DataCenter.crossServerRechargeData.consume_index + 1;
	if 	DataCenter.crossServerRechargeData.is_max_select_index then
		DataCenter.crossServerRechargeData.consume_index = DataCenter.crossServerRechargeData.max_select_index;
	end
	local info = DataCenter.crossServerRechargeData:getAccRewaedInfo(DataCenter.crossServerRechargeData.consume_index);
	self:updateExtraAwardInfo(info) -- 更新额外奖励数据
end

function Lua_CrossServerConsumeWindow:onAwardeClick()
	Lua_ProxyManager.getProxy("Lua_CrossServerRechargeProxy"):sGetConsumeAwardeInfo(self.data.index);
end

function Lua_CrossServerConsumeWindow:onRechargeClick()
	Lua_WindowUtil.openWin("Lua_ShopWindow", WinParam.ACTION_OPEN);
	Lua_WindowUtil.openWin("Lua_CrossServerConsumeWindow",WinParam.ACTION_CLOSE);
end

-- 人物模型
function Lua_CrossServerConsumeWindow:showPalyModel(data)
	Lua_WindowUtil.openWin("Lua_PlayerInfoTipsWindow", WinParam.ACTION_CLOSE);
	local rankArr = DataCenter.crossServerRechargeData.getRankInfo;
	if rankArr ~= nil and rankArr[1] ~= nil and tonumber(rankArr[1].role_id) == tonumber(data.role_id) then
		local modelData = UsData();
		modelData.roleId = data.role_id;
		modelData.weapon_id = data.equip_list.weapon; -- 武器
		modelData.clothes_id = data.equip_list.clothes; -- 衣服
		modelData.fashion_weapon_id = data.fashion_weapon_id; -- 时装 武器 id
		modelData.fashion_clothes_id = data.fashion_clothes_id;-- 时装 衣服 id
		modelData.fashionHeadId = data.fashion_headdress_id; -- 时装 头饰 id
		modelData.career = data.career; -- 职业
		modelData.wingId = data.equip_list.wing_shape; -- 神翼
		modelData.fairyId = data.equip_list.fairy_act_shape; -- 仙器
		modelData.faqiId = data.equip_list.magic_weapon_shape; -- 法宝
		modelData.spoorId = data.equip_list.spoor_shape;   -- 足迹
		modelData.showShadow = false;
		modelData.canBeClick = false;
		modelData.isShowName = false;
		modelData.IsUI = true;
		modelData.hp = 1;
		modelData.kind = 1;

		if self.playerModel ~= nil then
			self.playerModel:dispose();
			self.playerModel = nil;
		end
		self.playerModel = ModelPlayer(); 
		self.playerModel:init(self.content, Vector3(-11, -165, 500), Vector3(0, 90, 0), modelData, nil, 160);
		self.playerModel:addLuaLoadedCallBack(self, self.onModelLoaded);
		self.playerModel:setRotEnable(true, 0, 130, 280, 300, 2);
		self.playerModel:SetRenderQueue(self.nameTxt, 5, 2);
	end
end

function Lua_CrossServerConsumeWindow:onHelp()
	if DataCenter.crossServerRechargeData.travel_act == 1 then
		Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_AUTO, LanUtil.getValue(141025));
	else
		Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_AUTO, LanUtil.getValue(141026));
	end
end

function Lua_CrossServerConsumeWindow:dispose()	
	if self.awardList ~= nil then
		self.awardList:dispose()
		self.awardList = nil;
	end
	if self.rankList ~= nil then
		self.rankList:dispose()
		self.rankList = nil;
	end
	if self.showRewardList ~= nil then
		self.showRewardList:dispose();
		self.showRewardList = nil;
	end
	if self.rItem ~= nil then
		self.rItem:dispose();
		self.rItem = nil;
	end
	if self.playerModel ~= nil then
		self.playerModel:dispose();
		self.playerModel = nil;
	end
	self:endTimer();

	self:superCall("dispose");
end





--------------------------------------------------





Lua_CrossConsumeAwardItem = class("Lua_CrossConsumeAwardItem", Lua_ListCell);
function Lua_CrossConsumeAwardItem:ctor(p)
	self:superCall("ctor", p, "CrossConsumeAwardItem_skin");
end

function Lua_CrossConsumeAwardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rItem = Lua_RewardItem.new(self.content);
	self.rItem:setMaxShow(5);
	self.rItem:setLayout(60, 60, 7);
	self.rItem:setDepth(10);
	self.rItem:setClickWin(true);
	self.rItem:setMouseEnble(true);
	self.rItem:setItemScale(0.7, 0.7);
	self.rItem:setLocation(-138.5, -11.5, 0);
end

function Lua_CrossConsumeAwardItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.name.text = LanUtil.formateStr(LanUtil.getValue(141016), tostring(data.rank), tostring(data.num));
	self.rItem:setRewardByArray(data.itemArr);
end

function Lua_CrossConsumeAwardItem:checkOutBound(showRect)
	if self._data == nil then
		return;
	end

	local rect = Lua_Rectangle.new(self.itemX, self.itemY -50, 80, 60);
	for i, v in ipairs(self.rItem.awords) do
		v:showRoundEff(showRect:containeRect(rect) and v.data.roundEffect);
		v:showStampEff(showRect:containeRect(rect) and v.data.roundEffect);
	end
end

function Lua_CrossConsumeAwardItem:dispose()
	if self.rItem ~= nil then
		self.rItem:dispose();
		self.rItem = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end





--------------------------------------------------





Lua_CrossConsumeRankItem = class("Lua_CrossConsumeRankItem", Lua_ListCell);
function Lua_CrossConsumeRankItem:ctor(p)
	self:superCall("ctor", p, "CrossConsumeRankItem_skin"); 
end

function Lua_CrossConsumeRankItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_CrossConsumeRankItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.name.text = "[85A8BE]" .. data.name .. "[-]";
	self.num.text = "[85A8BE]" .. data.money .. "[-]";
	if data.rank <= 3 then
		self.rank:setAltas("leaderBoard_atlas", "ui_paihang_widget_no" .. data.rank);
	else
		self.rankLab.text = data.rank;
	end

	self.rank:setEnable(data.rank <= 3);
	self.rankLab:setEnable(data.rank > 3);
end

function Lua_CrossConsumeRankItem:dispose()
	self._data = nil;
	self:superCall("dispose");
end





--------------------------------------------------





Lua_CrossConsumeShowRewardItem = class("Lua_CrossConsumeShowRewardItem", Lua_ListCell);
function Lua_CrossConsumeShowRewardItem:ctor(p)
	self:superCall("ctor", p); 
end

function Lua_CrossConsumeShowRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.toolImg = Lua_ToolImage.new(self.content);
	self.toolImg:setDepth(10);
	self.toolImg:setScale(0.7, 0.7);
	self.toolImg:setCanClick(false);
end

function Lua_CrossConsumeShowRewardItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.toolImg.data = data;
end

function Lua_CrossConsumeShowRewardItem:checkOutBound(showRect)
	if self._data == nil then
		return;
	end

	local rect = Lua_Rectangle.new(self.itemX - 40, self.itemY - 24, 70, 60);
	self.toolImg:showRoundEff(showRect:containeRect(rect) and self._data.roundEffect);
	self.toolImg:showStampEff(showRect:containeRect(rect) and self._data.roundEffect);
end

function Lua_CrossConsumeShowRewardItem:onPlayerSoundClick()
	Lua_PackUtil.showItemInfo(self._data, false, nil, false);
end

function Lua_CrossConsumeShowRewardItem:dispose()
	if self.toolImg ~= nil then
		self.toolImg:dispose();
		self.toolImg = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end