-- 跨服充值排行
Lua_CrossServerRechargeWindow  = class("Lua_CrossServerRechargeWindow",Lua_Window);
function Lua_CrossServerRechargeWindow:ctor(p)
	self:superCall("ctor");
	
	self.windowName = "Lua_CrossServerRechargeWindow";
	self.skinName = "CrossServerRechargeWindow_skin";
end

function Lua_CrossServerRechargeWindow:dispose()	
	if self.dragList ~= nil then
		self.dragList:dispose()
		self.dragList = nil;
	end
	if self.rnakDragList ~= nil then
		self.rnakDragList:dispose()
		self.rnakDragList = nil;
	end
	if self.playerModel ~= nil then
		self.playerModel:dispose();
	end
	Lua_CommonUtil.removeTimer(self, self.updateRechargeLeftTime);

	self:superCall("dispose");
end

function Lua_CrossServerRechargeWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.tips.text = LanUtil.getValue(141003);
	self.rankTxt.text = LanUtil.getValue(141008);
	self.red:setEnable(false);
	self.subBtn:setBtnEnable(false);
	self.title:setEnable(false);
	self.dragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 370, 430));
	self.dragList:setLocation(-364, -54, 0);
	self.dragList:setListCell(CrossRechargeRankItem, 105, 300, 1);

	self.rnakDragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 380, 180));
	self.rnakDragList:setLocation(353, 49, 0);
	self.rnakDragList:setListCell(CrossServerRankItem, 50, 90, 1);

	self.itemList = Lua_DragList.new(self.content, 2, Vector4(0, 0, 230, 60));
	self.itemList:setLocation(348, -201, 0);
	self.itemList:setListCell(CrossRechargeAwardItem, 60, 80, 100);

	-- 奖励展示
    self.item = Lua_RewardItem.new(self.content);
    self.item:buildShowItem();
    self.item:setLayout(65, 65, 7);
    self.item:setMaxShow(5);
    self.item:setDepth(self.depth + 10);
    self.item:setClickWin(true);
    self.item:setMouseEnble(true);
    self.item:setItemScale(0.76, 0.76);
    self.item.pivot = 2;
    self.item:setLocation(-10, -237, 0);

    self.help:addClickFuntion(self, self.onHelp);--问号
    self.add:addClickFuntion(self, self.onAddClick);   -- 上一页;
    self.sub:addClickFuntion(self, self.onSubClick);   -- 下一页;
    self.subBtn:addClickFuntion(self, self.onAwardeClick);        -- 领取奖励;
    self.rechargeBtn:addClickFuntion(self, self.onRechargeClick); -- 前往充值;
 
	self:addLuaEvent("UPDARE_RECHERGE_INFO", self, self.updateRechargeInfo);
	self:addLuaEvent("UPDARE_AWARD_INFO", self, self.updateAwardInfo);  -- 领取奖励后单独更新
	self:addLuaEvent("UPDTAE_PALY_INFO", self, self.showPalyModel);

	Lua_ProxyManager.getProxy("Lua_CrossServerRechargeProxy"):sUseRechargeInfo();

    self:updateRechargeLeftTime();	
	Lua_CommonUtil.addTimer("updateRechargeLeftTime", 1, self, self.updateRechargeLeftTime);
end

function Lua_CrossServerRechargeWindow:updateRechargeInfo()

	local  awardArr = DataCenter.crossServerRechargeData.getRankRewaedInfo;
	local  rankArr = DataCenter.crossServerRechargeData.getRankInfo;

    self.dragList:setLuaArrayData(awardArr, true);
    self.rnakDragList:setLuaArrayData(rankArr, true);

    self.item:setRewardByArray(DataCenter.crossServerRechargeData.getFirstAward);
	self.rank_tips.text = DataCenter.crossServerRechargeData.content; --LanUtil.formateStr(LanUtil.getValue(141002), tostring());
	self.nameTxt.text = DataCenter.crossServerRechargeData.getFirstName;
	self.centre_tips.text = DataCenter.crossServerRechargeData.getFirstRechargeNum;
	self.rank_text.text = DataCenter.crossServerRechargeData.rank_dic;

   
    if DataCenter.crossServerRechargeData.isHaveFirst == true then
    	self.play_bg:setEnable(false);
    	Lua_ProxyManager.getProxy("Lua_CrossServerRechargeProxy"):sUseRechargePalyInfo(rankArr[1].role_id,rankArr[1].server_flag);
    else
    	self.play_bg:setEnable(true);
    	if self.playerModel ~= nil then
    		self.playerModel:dispose();
    	end
    end

    if DataCenter.crossServerRechargeData.travel_act == 1 then
    	self.title:setAltas("crossServerRecharge_atlas", "ui_kfczph_z01");
    	self.title:setLocation(-167, 271);
    	self.title:SetDimensions(305, 53);
    else
    	self.title:setAltas("crossServerRecharge_atlas", "ui_czph_w04");
    	self.title:setLocation(-122, 271);
    	self.title:SetDimensions(202, 49);
    end
    self.title:setEnable(true);
	self:updateAwardInfo();
end

function Lua_CrossServerRechargeWindow:updateRechargeLeftTime()
	if DataCenter.roleData.serverTime == nil or DataCenter.crossServerRechargeData.end_tick == nil then
		return;
	end
	local leftTime = DataCenter.crossServerRechargeData.end_tick - DataCenter.roleData.serverTime;
	if leftTime - 1  > 0 then
		self.time.text = LanUtil.formateStr(LanUtil.getValue(141001), TimeTransform.getInstance():transSeconds1(leftTime - 1,true));
	else
		self.time.text = LanUtil.formateStr(LanUtil.getValue(141001), tostring(0)).."[FF1818FF]"..LanUtil.getValue(26);
		Lua_CommonUtil.removeTimer(self,self.updateRechargeLeftTime);
	end
end

function Lua_CrossServerRechargeWindow:updateAwardInfo()

	self.award_text.text = LanUtil.formateStr(LanUtil.getValue(141006), tostring(DataCenter.crossServerRechargeData.total_gold));
    if DataCenter.crossServerRechargeData.getAwardIndex == 1 then
    	DataCenter.crossServerRechargeData.recharge_index = 1;
    else
    	DataCenter.crossServerRechargeData.recharge_index = DataCenter.crossServerRechargeData.getAwardIndex;
    end

    local info = DataCenter.crossServerRechargeData:getAccRewaedInfo(DataCenter.crossServerRechargeData.recharge_index);
    self:updateExtraAwardInfo(info) -- 更新额外奖励数据
end

function Lua_CrossServerRechargeWindow:updateExtraAwardInfo(data) -- 更新额外奖励数据
	self.data = data;

	self.itemList:setLuaArrayData(data.itemArr, true);

	if 	DataCenter.crossServerRechargeData.is_max_select_index == true then
		self.sub:setAltas("common_atlas_2", "ui_common_jiantou_01");
		self.sub.mouseEnable = true;
		self.add.mouseEnable = false;
		self.add:setAltas("common_atlas_2", "ui_common_jiantou_02");
	else
		self.add:setAltas("common_atlas_2", "ui_common_jiantou_01");
		self.add.mouseEnable = true;
		if DataCenter.crossServerRechargeData.recharge_index == 1 then
			self.sub:setAltas("common_atlas_2", "ui_common_jiantou_02");
			self.sub.mouseEnable = false;
		else
			self.sub:setAltas("common_atlas_2", "ui_common_jiantou_01");
			self.sub.mouseEnable = true;
		end
	end

    self.recharge_text.text = data.content;
    if data.state == 0 then--不可领
    	self.red:setEnable(false);
    	self.subBtn:setBtnEnable(false);
    	self.subBtn.label = LanUtil.getValue(121148);
    elseif data.state == 1 then--可领取
    	self.red:setEnable(true);
    	self.subBtn:setBtnEnable(true);
    	self.subBtn.label = LanUtil.getValue(121148);
    else
    	self.red:setEnable(false);
    	self.subBtn:setBtnEnable(false);
    	self.subBtn.label = LanUtil.getValue(121912);
    end
end

function Lua_CrossServerRechargeWindow:onSubClick()
	DataCenter.crossServerRechargeData.recharge_index = DataCenter.crossServerRechargeData.recharge_index  - 1;
	if DataCenter.crossServerRechargeData.recharge_index == 0 then
		DataCenter.crossServerRechargeData.recharge_index = 1;
	end
	local info = DataCenter.crossServerRechargeData:getAccRewaedInfo(DataCenter.crossServerRechargeData.recharge_index)
    self:updateExtraAwardInfo(info) -- 更新额外奖励数据
end

function Lua_CrossServerRechargeWindow:onAddClick()
	DataCenter.crossServerRechargeData.recharge_index = DataCenter.crossServerRechargeData.recharge_index  + 1;

	if 	DataCenter.crossServerRechargeData.is_max_select_index == true then
		DataCenter.crossServerRechargeData.recharge_index = DataCenter.crossServerRechargeData.max_select_index;
	end
	local info = DataCenter.crossServerRechargeData:getAccRewaedInfo(DataCenter.crossServerRechargeData.recharge_index)
    self:updateExtraAwardInfo(info) -- 更新额外奖励数据
end

function Lua_CrossServerRechargeWindow:onAwardeClick()
	Lua_ProxyManager.getProxy("Lua_CrossServerRechargeProxy"):sGetRechargeAwardeInfo(self.data.index);
end

function Lua_CrossServerRechargeWindow:onRechargeClick()
	Lua_WindowUtil.openWin("Lua_ChongzhiWindow",WinParam.ACTION_OPEN, 1);
	Lua_WindowUtil.openWin("Lua_CrossServerRechargeWindow",WinParam.ACTION_CLOSE);
end

function Lua_CrossServerRechargeWindow:showPalyModel(data)-- 人物模型
	Lua_WindowUtil.openWin("Lua_PlayerInfoTipsWindow", WinParam.ACTION_CLOSE);
	local rankArr = DataCenter.crossServerRechargeData.getRankInfo;
	if rankArr ~= nil and rankArr[1] ~= nil and tonumber(rankArr[1].role_id) == tonumber(data.role_id) then
	    local modelData = UsData();
	    modelData.roleId = data.role_id;
	    modelData.weapon_id = data.equip_list.weapon; -- 武器
	    modelData.clothes_id = data.equip_list.clothes; -- 衣服
	    modelData.fashion_weapon_id = data.fashion_weapon_id; -- 时装 武器 id
	    modelData.fashion_clothes_id = data.fashion_clothes_id;-- 时装 衣服 id
	    modelData.fashionHeadId = data.fashion_headdress_id; -- 时装 头饰 id
	    modelData.career = data.career; -- 职业
	    modelData.wingId = data.equip_list.wing_shape; -- 神翼
	    modelData.fairyId = data.equip_list.fairy_act_shape; -- 仙器
	    modelData.faqiId = data.equip_list.magic_weapon_shape; -- 法宝
	    modelData.spoorId = data.equip_list.spoor_shape;   -- 足迹
	    modelData.showShadow = false;
	    modelData.canBeClick = false;
	    modelData.isShowName = false;
	    modelData.IsUI = true;
	    modelData.hp = 1;
	    modelData.kind = 1;
	    local pos = Vector3(-16, -168, 500);
	    local rot = Vector3(0, 90, 0);
	    local scale = 160;
	    if self.playerModel ~= nil then
	    	self.playerModel:dispose();
	    	self.playerModel = nil;
	    end
	    self.playerModel = ModelPlayer(); 
	    self.playerModel:init(self.content, pos, rot, modelData, nil, scale);
	    self.playerModel:addLuaLoadedCallBack(self, self.onModelLoaded);
	    self.playerModel:setRotEnable(true, 0, 200, 280, 400, 2);
	    self.playerModel:SetRenderQueue(self.nameTxt, 5, 2);
	end
end

function Lua_CrossServerRechargeWindow:onHelp()
	if DataCenter.crossServerRechargeData.travel_act == 1 then
		Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_AUTO, LanUtil.getValue(141023));
    else
    	Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_AUTO, LanUtil.getValue(141024));
    end
end











CrossRechargeRankItem = class("CrossRechargeRankItem", Lua_ListCell);
function CrossRechargeRankItem:ctor(p)
	self:superCall("ctor", p,"CrossRechargeRankItem_skin");
end

function CrossRechargeRankItem:buildShowItem()
	self:superCall("buildShowItem");
	-- 奖励展示
    self.rItem = Lua_RewardItem.new(self.content);
    self.rItem:buildShowItem();
    self.rItem:setLayout(70, 70, 7);
    self.rItem:setMaxShow(5);
    self.rItem:setDepth(self.depth+10);
    self.rItem:setClickWin(true);
    self.rItem:setMouseEnble(true);
    self.rItem:setItemScale(0.76, 0.76);
    self.rItem:setLocation(-105, -15, 0);
end

function CrossRechargeRankItem:setData(data)
	self.data = data;
	self.name.text = LanUtil.formateStr(LanUtil.getValue(141009), tostring(data.rank), tostring(data.num));
	self.rItem:setRewardByArray(data.itemArr);
end

function CrossRechargeRankItem:checkOutBound(showRect)
	if self.data == nil then
		self.inViewEffect = false;
		return;
	end
	local rect = Lua_Rectangle.new(self.itemX, self.itemY -50, 80, 60);
	if showRect:containeRect(rect) == true then
		self.inViewEffect = true;
	else
		self.inViewEffect = false;
	end
	self:updateEffectState();
end

function CrossRechargeRankItem:updateEffectState()
	local list = self.rItem.awords;
	if self.inViewEffect == true then
		for i, v in ipairs(list) do
			if v.data.roundEffect == true then
				if v.data.subType == Lua_PackTypeDefine.ARMY_EQUIP_ITEM and v.armyEff == nil then
					v:showRoundEff(true);
				else
					if v.roundEff == nil then
						v:showRoundEff(true);
					end
				end
				if v.stampEff == nil then
					v:showStampEff(true);
				end
			else
				v:showRoundEff(false);
				v:showStampEff(false);
			end
		end
	else
		for i, v in ipairs(list) do
			v:showRoundEff(false);
			v:showStampEff(false);
		end
	end
end

function CrossRechargeRankItem:dispose()
	self:superCall("dispose");
end














CrossServerRankItem = class("CrossServerRankItem", Lua_ListCell);
function CrossServerRankItem:ctor(p)
	self:superCall("ctor", p,"CrossServerRankItem_skin"); 
end

function CrossServerRankItem:buildShowItem()
	self:superCall("buildShowItem");
end

function CrossServerRankItem:setData(data)
	self.name.text = "[85A8BE]"..data.name.."[-]";
	if data.rank <= 3 then
		self.rank:setEnable(true);
		self.rank_num.uiwidget.gameObject:SetActive(false);
		self.rank:setAltas("leaderBoard_atlas", "ui_paihang_widget_no" .. data.rank);
	else
		self.rank:setEnable(false);
		self.rank_num.uiwidget.gameObject:SetActive(true);
		self.rank_num.text = data.rank;
	end
	self.num.text = "[85A8BE]"..data.money.."[-]";
end

function CrossServerRankItem:dispose()
	self:superCall("dispose");
end














CrossRechargeAwardItem = class("CrossRechargeAwardItem", Lua_ListCell);
function CrossRechargeAwardItem:ctor(p)
	self:superCall("ctor", p,nil); 
end

function CrossRechargeAwardItem:buildShowItem()
	self:superCall("buildShowItem");
	self.image = Lua_ToolImage.new(self.content);
    self.image:setDepth(6);
    self.image:setLocation(0, 0, 0);
    self.image:setCanClick(false);
end

function CrossRechargeAwardItem:setData(data)
	self.data = data;
	self.image:setScale(0.76, 0.76)
	self.image.data = data;
end

function CrossRechargeAwardItem:checkOutBound(showRect)
	if self.data == nil then
		self.inViewEffect = false;
		return;
	end
	local rect = Lua_Rectangle.new(self.itemX - 30, self.itemY, 60, 0);
	if showRect:containeRect(rect) == true then
		if self.data.roundEffect == true then
			self.inViewEffect = true;
		else
			self.inViewEffect = false;
		end
	else
		self.inViewEffect = false;
	end
	self:updateEffectState();
end

function CrossRechargeAwardItem:updateEffectState()
	if self.inViewEffect == true then
		if self.data.subType == Lua_PackTypeDefine.ARMY_EQUIP_ITEM and self.image.armyEff == nil then
			self.image:showRoundEff(true);
		else
			if self.image.roundEff == nil then
				self.image:showRoundEff(true);
			end
		end

		if self.data.subType == Lua_PackTypeDefine.STAMP_ITEM and self.image.stampEff == nil then
			self.image:showStampEff(true);
		end
	else
		self.image:showRoundEff(false);
		self.image:showStampEff(false);
	end
end

function CrossRechargeAwardItem:onPlayerSoundClick()
	Lua_PackUtil.showItemInfo(self.data, false, nil, false);
end

function CrossRechargeAwardItem:dispose()
	self:superCall("dispose");
end